package xcastbot.ui;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import xcraftbot.xcraftobjects.PlantType;

public class MainFrame extends JFrame{

    private String name;
    private String password;
    private JTabbedPane tabbedPane;
    private PlantPanel panelOkari;
    private PlantPanel panelNoa;
    private ZuchtPanel panelZucht;
    
    public MainFrame(String title, String name, String password){
        setTitle(title);
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.name=name;
        this.password=password;
        this.tabbedPane = new JTabbedPane();
        getContentPane().add(tabbedPane);
        
        panelOkari = new PlantPanel(PlantType.OKARI_NUSS, name, password);
        panelNoa = new PlantPanel(PlantType.NOA_BLATT, name, password);
        panelZucht = new ZuchtPanel(name, password,this);
        
        tabbedPane.add("Okari-Nuesse", panelOkari);
        tabbedPane.add("Noa-Blaetter", panelNoa);
        tabbedPane.add("Zucht", panelZucht);
        
        
        setSize(800, 600);
        setVisible(true);
    }

    // <editor-fold defaultstate="collapsed" desc=" Region: Getter und Setter ">
    public PlantPanel getPanelOkari() {
        return panelOkari;
    }
    
    public PlantPanel getPanelNoa() {
        return panelNoa;
    }
    
    public ZuchtPanel getPanelZucht() {
        return panelZucht;
    }
    
    public String getName() {
        return name;
    }
    
    public void setName(String name) {
        this.name = name;
    }
    
    public String getPassword() {
        return password;
    }
    
    public void setPassword(String password) {
        this.password = password;
    }

// </editor-fold>
    
    
    
}
