package xcastbot.ui;

import io.github.bonigarcia.wdm.WebDriverManager;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import xcraftbot.logic.ButtonNavigate;
import xcraftbot.logic.Textbox;
import xcraftbot.xcraftobjects.Plant;
import xcraftbot.xcraftobjects.PlantType;

public class XCastPlantFarm {
    
    private WebDriver driverLogin;
    private JFrame frame;
    private PlantPanel panelOkari;
    private PlantPanel panelNoa;
    private ZuchtPanel panelZucht;
    private String name;
    private String password;
    
    public XCastPlantFarm(){
        WebDriverManager.chromedriver().setup();
        driverLogin = new ChromeDriver();
        
        JFrame frameLogin = new JFrame("Login");
        frameLogin.setSize(300, 300);
        frameLogin.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JPanel panelLogin = new JPanel();
        panelLogin.setLayout(null);
        
        JLabel lblName = new JLabel("Name:");
        JTextField txtName = new JTextField();
        JLabel lblPassword = new JLabel("Password:");
        JPasswordField txtPassword = new JPasswordField();
        JButton btnBotLogin = new JButton("Login");
        JLabel lblMessage = new JLabel("");
        
        lblName.setBounds(10, 10, 100, 30);
        txtName.setBounds(120, 10, 100, 30);
        lblPassword.setBounds(10, 50, 100, 30);
        txtPassword.setBounds(120,50,100,30);
        btnBotLogin.setBounds(10, 90, 210, 30);
        lblMessage.setBounds(10,130,210,30);
        
        lblMessage.setForeground(Color.RED);
        
        panelLogin.add(lblName);
        panelLogin.add(txtName);
        panelLogin.add(lblPassword);
        panelLogin.add(txtPassword);
        panelLogin.add(btnBotLogin);
        panelLogin.add(lblMessage);
        
        btnBotLogin.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean successfull = loginToXCraftCrafting(driverLogin, txtName.getText(), txtPassword.getText());
                if(successfull){
                    name = txtName.getText();
                    password = txtPassword.getText();
                    frameLogin.dispose();
                    driverLogin.quit();
                    MainFrame mainFrame = new MainFrame("Zucht Manager",name, password);
                }else{
                    lblMessage.setText("Login failed");
                }
            }
        });
        txtPassword.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean successfull = loginToXCraftCrafting(driverLogin, txtName.getText(), txtPassword.getText());
                if(successfull){
                    name = txtName.getText();
                    password = txtPassword.getText();
                    frameLogin.dispose();
                    driverLogin.quit();
                    MainFrame mainFrame = new MainFrame("Zucht Manager",name, password);
                }else{
                    lblMessage.setText("Login failed");
                }
            }
        });
        
        frameLogin.add(panelLogin);
        frameLogin.setVisible(true);
    }
    
    public static void main(String[] args) {
        XCastPlantFarm ui = new XCastPlantFarm();
    }
    
    public boolean loginToXCraftCrafting(WebDriver driver, String username, String password){
        try{
        driver.get("https://xcraftkkrieger.cx.edvschule-plattling.de/XCraft/");
        WebElement boxName = driver.findElement(By.name(Textbox.USERNAME.getNameString()));
        boxName.sendKeys(username);
        WebElement boxPassword = driver.findElement(By.name(Textbox.PASSWORD.getNameString()));
        boxPassword.sendKeys(password);
        WebElement btnLogin = driver.findElement(By.name(ButtonNavigate.LOGIN.getNameString()));
        btnLogin.click();
        WebElement elem = findWebElementByText(driverLogin,"Rohstoffe");
        return elem!=null;
        }catch(Exception e){
            return false;
        }
    }
    public void clickButtonByValue(WebDriver driver,String value){
        driver.findElement(By.xpath("//input[@value='"+value+"']")).click();
    }
    public int countByText(WebDriver driver, String text){
        List<WebElement> webElements = driver.findElements(By.xpath("//*[contains(text(), '"+text+"')]"));
        return webElements.size();
    }
    public WebElement findWebElementByText(WebDriver driver, String text){
        WebElement elem = driver.findElement(By.xpath("//*[contains(text(), '"+text+"')]"));
        return elem;
    }
    public List<Plant> loadPlants(WebDriver driver){
        JFrame frame = new JFrame("Loading Plants!");
        frame.setSize(200, 100);
        frame.setLocation(500, 500);
        JLabel lblStatus = new JLabel("Loaded: 0");
        frame.getContentPane().add(lblStatus);
        frame.setVisible(true);
        List<Plant> plants = new ArrayList<>();
        int count = 0;
        for(PlantType planttype:PlantType.values()){
            System.out.println("Start findElements");
            List<WebElement> webElements = driver.findElements(By.xpath("//*[contains(text(), '"+planttype.getBezeichnung()+"')]"));
            System.out.println("End findElements");
            for(WebElement elem: webElements){
                String text = elem.getText();
                String klammern = elem.getText().substring(text.indexOf("(")+1, text.indexOf(")"));
                String[] parts = klammern.split("/");
                plants.add(new Plant(planttype, Integer.parseInt(parts[0]), Integer.parseInt(parts[1]), Integer.parseInt(parts[2])));
                count++;
                lblStatus.setText("Loaded: "+count);
                System.out.print("adding");
            }
            System.out.println("");
                    
        }
        System.out.println("Done loading");
        return plants;
    }
    
}
