package xcastbot.ui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import javax.swing.JPanel;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import xcraftbot.logic.ButtonNavigate;
import xcraftbot.logic.Textbox;
import xcraftbot.xcraftobjects.PlantType;

public class ZuchtPanel extends JPanel{
    
    private WebDriver driverZucht;
    private TopfPanel panelTopf_1;
    private TopfPanel panelTopf_2;
    private TopfPanel panelTopf_3;
    private TopfPanel panelTopf_4;
    private MainFrame mainFrame;
    
    public ZuchtPanel(String name, String passwort, MainFrame mainFrame){
        super();
        setLayout(new GridBagLayout());
        this.mainFrame = mainFrame;
        panelTopf_1 = new TopfPanel(1,this);
        panelTopf_2 = new TopfPanel(2,this);
        panelTopf_3 = new TopfPanel(3,this);
        panelTopf_4 = new TopfPanel(4,this);
        
        add(panelTopf_1,makeGridBagConstraint(1, 0, 0));
        add(panelTopf_2,makeGridBagConstraint(1, 0, 1));
        add(panelTopf_3,makeGridBagConstraint(1, 0, 2));
        add(panelTopf_4,makeGridBagConstraint(1, 0, 3));
    }
    
    public void repaintPublic(){
        revalidate();
        repaint();
    }
    
    //<editor-fold defaultstate="collapsed" desc="Utils">
    private GridBagConstraints makeGridBagConstraint(int fill, int x, int y) {
        GridBagConstraints c = new GridBagConstraints();
        c.fill = fill;
        c.gridx = x;
        c.gridy = y;
        c.insets = new Insets(3, 3, 3, 3);
        return c;
    }
    private GridBagConstraints makeGridBagConstraint(int fill, int x, int y, int gridwidth, int gridheigt) {
        GridBagConstraints c = makeGridBagConstraint(fill, x, y);
        c.gridwidth = gridwidth;
        c.gridheight = gridheigt;
        return c;
    }
    public boolean loginToXCraftCrafting(WebDriver driver, String username, String password){
        System.out.println("Logging in");
        try{
            driver.get("https://xcraftkkrieger.cx.edvschule-plattling.de/XCraft/");
            WebElement boxName = driver.findElement(By.name(Textbox.USERNAME.getNameString()));
            boxName.sendKeys(username);
            WebElement boxPassword = driver.findElement(By.name(Textbox.PASSWORD.getNameString()));
            boxPassword.sendKeys(password);
            WebElement btnLogin = driver.findElement(By.name(ButtonNavigate.LOGIN.getNameString()));
            btnLogin.click();
            WebElement elem = findWebElementByText(driver,"Rohstoffe");
            return elem!=null;
        }catch(Exception e){
            
            e.printStackTrace();
            return false;
        }
    }
    public WebElement findWebElementByText(WebDriver driver, String text){
        WebElement elem = driver.findElement(By.xpath("//*[contains(text(), '"+text+"')]"));
        return elem;
    }
    public void clickButtonByValue(WebDriver driver,String value){
        driver.findElement(By.xpath("//input[@value='"+value+"']")).click();
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Getter und Setter">
    public MainFrame getMainFrame() {
        return mainFrame;
    }
    //</editor-fold>
    
    public void removeAtPanels(int index, PlantType type){
        panelTopf_1.removeAtIndex(index, type);
        panelTopf_2.removeAtIndex(index, type);
        panelTopf_3.removeAtIndex(index, type);
        panelTopf_4.removeAtIndex(index, type);
        System.out.println("re-done comboboxes");
    }
}
