/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package xcraftbot.ui;

import io.github.bonigarcia.wdm.WebDriverManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import org.openqa.selenium.By;
import org.openqa.selenium.JavascriptExecutor;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.chrome.ChromeDriver;
import xcraftbot.logic.ButtonNavigate;
import xcraftbot.logic.Textbox;

/**
 *
 * @author agreiner
 */
public class XCastHealthFarm {
    
    public XCastHealthFarm(){
        WebDriverManager.chromedriver().setup();
        WebDriver driverMain = new ChromeDriver();
        WebDriver driverBot = new ChromeDriver();
        
        JFrame frame = new JFrame("Marketplace");
        frame.setSize(600, 600);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        JPanel panel = new JPanel();
        panel.setLayout(null);
        
        JLabel lblBotName = new JLabel("Bot Name:");
        JTextField txtBotName = new JTextField();
        JLabel lblBotPassword = new JLabel("Bot Password:");
        JPasswordField txtBotPassword = new JPasswordField();
        
        JLabel lblMainName = new JLabel("Main Name:");
        JTextField txtMainName = new JTextField();
        JLabel lblMainPassword = new JLabel("Main Password:");
        JPasswordField txtMainPassword = new JPasswordField();
        
        
        JButton btnBotLogin = new JButton("Login");
        
        lblBotName.setBounds(10, 10, 100, 30);
        txtBotName.setBounds(120, 10, 100, 30);
        lblBotPassword.setBounds(10, 50, 100, 30);
        txtBotPassword.setBounds(120,50,100,30);
        
        lblMainName.setBounds(250, 10, 100, 30);
        txtMainName.setBounds(360, 10, 100, 30);
        lblMainPassword.setBounds(250, 50, 100, 30);
        txtMainPassword.setBounds(360,50,100,30);
        
        btnBotLogin.setBounds(10, 90, 450, 30);
        
        panel.add(lblBotName);
        panel.add(txtBotName);
        panel.add(lblBotPassword);
        panel.add(txtBotPassword);
        
        panel.add(lblMainName);
        panel.add(txtMainName);
        panel.add(lblMainPassword);
        panel.add(txtMainPassword);
        
        panel.add(btnBotLogin);
        
        btnBotLogin.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean success=true;
                try{
                    loginToXCraftCrafting(driverBot, txtBotName.getText(), txtBotPassword.getText());
                    loginToXCraftCrafting(driverMain, txtMainName.getText(), txtMainPassword.getText());
                    panel.removeAll();
                    panel.repaint();
                    frame.repaint();
                }catch (Exception ex){
                    System.out.println("Login failed!");
                    success=false;
                }
                if(success){
                    init(frame, panel, txtBotName.getText(), driverBot, txtMainName.getText(), driverMain);
                }
                
            }
        });
        
        
        
        
        
        
        
        frame.add(panel);
        frame.setVisible(true);
        frame.setVisible(true);
    }
    
    public void init(JFrame frame, JPanel panel,String botName, WebDriver driverBot, String mainName, WebDriver driverMain){
        
        JLabel lblBotName = new JLabel(botName);
        lblBotName.setBounds(10, 10, 100, 30);
        
        JLabel lblMainName = new JLabel(mainName);
        lblMainName.setBounds(310, 10,100,30);
        panel.add(lblBotName);
        panel.add(lblMainName);
        
        clickButtonByValue(driverBot, "XCast");
        clickButtonByValue(driverMain, "XCast");
        
        JLabel lblBotCount = new JLabel("Okari-Nuesse: "+countByText(driverBot,"Okari"));
        JLabel lblMainCount = new JLabel("Okari-Nuesse: "+countByText(driverMain,"Okari"));
        
        lblBotCount.setBounds(15, 50, 150, 30);
        lblMainCount.setBounds(315, 50, 150, 30);
        panel.add(lblBotCount);
        panel.add(lblMainCount);
        
        
    }
    
    public static void main(String[] args) {
        XCastHealthFarm ui = new XCastHealthFarm();
    }
    
    public boolean loginToXCraftCrafting(WebDriver driver, String username, String password){
        driver.get("https://xcraftkkrieger.cx.edvschule-plattling.de/XCraft/");
        WebElement boxName = driver.findElement(By.name(Textbox.USERNAME.getNameString()));
        boxName.sendKeys(username);
        WebElement boxPassword = driver.findElement(By.name(Textbox.PASSWORD.getNameString()));
        boxPassword.sendKeys(password);
        WebElement btnLogin = driver.findElement(By.name(ButtonNavigate.LOGIN.getNameString()));
        btnLogin.click();
        return true;
    }
    
    public void clickButtonByValue(WebDriver driver,String value){
        driver.findElement(By.xpath("//input[@value='"+value+"']")).click();
    }
    
    public int countByText(WebDriver driver, String text){
        
        List<WebElement> webElements = driver.findElements(By.xpath("//*[contains(text(), '"+text+"')]"));
        return webElements.size();
    }
}
