package xcraftbot.xcraftobjects;

public class Plant implements Comparable<Plant>{
    
    private PlantType type;
    private int illnessResistance;
    private int pestResistance;
    private int effectifity;

    public Plant(PlantType type, int illnessResistance, int pestResistance, int effectifity) {
        this.type = type;
        this.illnessResistance = illnessResistance;
        this.pestResistance = pestResistance;
        this.effectifity = effectifity;
    }

    public PlantType getType() {
        return type;
    }

    public void setType(PlantType type) {
        this.type = type;
    }

    public int getIllnessResistance() {
        return illnessResistance;
    }

    public void setIllnessResistance(int illnessResistance) {
        this.illnessResistance = illnessResistance;
    }

    public int getPestResistance() {
        return pestResistance;
    }

    public void setPestResistance(int pestResistance) {
        this.pestResistance = pestResistance;
    }

    public int getEffectifity() {
        return effectifity;
    }

    public void setEffectifity(int effectifity) {
        this.effectifity = effectifity;
    }
    
    public int totoalStats(){
        return illnessResistance+pestResistance+effectifity;
    }
    
    public boolean isMax(){
        return totoalStats()==300;
    }

    @Override
    public String toString() {
        return type.getBezeichnung()+" ("+illnessResistance+"/"+pestResistance+"/"+effectifity+") "+totoalStats();
    
    }
    
    public String toRealString() {
        return type.getBezeichnung()+" ("+illnessResistance+"/"+pestResistance+"/"+effectifity+")";
    
    }

    @Override
    public int compareTo(Plant o) {
        return this.totoalStats()-o.totoalStats();
    }

    public static Plant parsePlant(String plantString){
        
        String typeString = plantString.split(" ")[0];
        PlantType type;
        if(typeString.equals("Okari-Nuss")){
            type=PlantType.OKARI_NUSS;
        }else{
            type=PlantType.NOA_BLATT;
        }
        String klammern = plantString.substring(plantString.indexOf("(")+1, plantString.indexOf(")"));
        String[] parts = klammern.split("/");
        Plant p = new Plant(type, Integer.parseInt(parts[0]), Integer.parseInt(parts[1]), Integer.parseInt(parts[2]));
        return p;
    }
    
}
